require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_PROC_LOCKS_H)) {
    eval 'sub __ASM_PROC_LOCKS_H () {1;}' unless defined(&__ASM_PROC_LOCKS_H);
    if((defined(&__LINUX_ARM_ARCH__) ? &__LINUX_ARM_ARCH__ : 0) >= 6) {
	eval 'sub __down_op {
	    local($ptr,$fail) = @_;
    	    eval q(({  &__asm__  &__volatile__( \\"@ down_op\\\\n\\" \\"1:	ldrex	lr, [%0]\\\\n\\" \\"	sub	lr, lr, %1\\\\n\\" \\"	strex	ip, lr, [%0]\\\\n\\" \\"	teq	ip, #0\\\\n\\" \\"	bne	1b\\\\n\\" \\"	teq	lr, #0\\\\n\\" \\"	movmi	ip, %0\\\\n\\" \\"	blmi	\\" $fail : : \\"r\\" ($ptr), \\"I\\" (1) : \\"ip\\", \\"lr\\", \\"cc\\");  &smp_mb(); }));
	}' unless defined(&__down_op);
	eval 'sub __down_op_ret {
	    local($ptr,$fail) = @_;
    	    eval q(({ \'unsigned int ret\';  &__asm__  &__volatile__( \\"@ down_op_ret\\\\n\\" \\"1:	ldrex	lr, [%1]\\\\n\\" \\"	sub	lr, lr, %2\\\\n\\" \\"	strex	ip, lr, [%1]\\\\n\\" \\"	teq	ip, #0\\\\n\\" \\"	bne	1b\\\\n\\" \\"	teq	lr, #0\\\\n\\" \\"	movmi	ip, %1\\\\n\\" \\"	movpl	ip, #0\\\\n\\" \\"	blmi	\\" $fail \\"\\\\n\\" \\"	mov	%0, ip\\" : \\"=&r\\" ( &ret) : \\"r\\" ($ptr), \\"I\\" (1) : \\"ip\\", \\"lr\\", \\"cc\\");  &smp_mb();  &ret; }));
	}' unless defined(&__down_op_ret);
	eval 'sub __up_op {
	    local($ptr,$wake) = @_;
    	    eval q(({  &smp_mb();  &__asm__  &__volatile__( \\"@ up_op\\\\n\\" \\"1:	ldrex	lr, [%0]\\\\n\\" \\"	add	lr, lr, %1\\\\n\\" \\"	strex	ip, lr, [%0]\\\\n\\" \\"	teq	ip, #0\\\\n\\" \\"	bne	1b\\\\n\\" \\"	cmp	lr, #0\\\\n\\" \\"	movle	ip, %0\\\\n\\" \\"	blle	\\" $wake : : \\"r\\" ($ptr), \\"I\\" (1) : \\"ip\\", \\"lr\\", \\"cc\\"); }));
	}' unless defined(&__up_op);
	eval 'sub RW_LOCK_BIAS () {0x1000000;}' unless defined(&RW_LOCK_BIAS);
	eval 'sub RW_LOCK_BIAS_STR () {"0x01000000";}' unless defined(&RW_LOCK_BIAS_STR);
	eval 'sub __down_op_write {
	    local($ptr,$fail) = @_;
    	    eval q(({  &__asm__  &__volatile__( \\"@ down_op_write\\\\n\\" \\"1:	ldrex	lr, [%0]\\\\n\\" \\"	sub	lr, lr, %1\\\\n\\" \\"	strex	ip, lr, [%0]\\\\n\\" \\"	teq	ip, #0\\\\n\\" \\"	bne	1b\\\\n\\" \\"	teq	lr, #0\\\\n\\" \\"	movne	ip, %0\\\\n\\" \\"	blne	\\" $fail : : \\"r\\" ($ptr), \\"I\\" ( &RW_LOCK_BIAS) : \\"ip\\", \\"lr\\", \\"cc\\");  &smp_mb(); }));
	}' unless defined(&__down_op_write);
	eval 'sub __up_op_write {
	    local($ptr,$wake) = @_;
    	    eval q(({  &smp_mb();  &__asm__  &__volatile__( \\"@ up_op_write\\\\n\\" \\"1:	ldrex	lr, [%0]\\\\n\\" \\"	adds	lr, lr, %1\\\\n\\" \\"	strex	ip, lr, [%0]\\\\n\\" \\"	teq	ip, #0\\\\n\\" \\"	bne	1b\\\\n\\" \\"	movcs	ip, %0\\\\n\\" \\"	blcs	\\" $wake : : \\"r\\" ($ptr), \\"I\\" ( &RW_LOCK_BIAS) : \\"ip\\", \\"lr\\", \\"cc\\"); }));
	}' unless defined(&__up_op_write);
	eval 'sub __down_op_read {
	    local($ptr,$fail) = @_;
    	    eval q( &__down_op($ptr, $fail));
	}' unless defined(&__down_op_read);
	eval 'sub __up_op_read {
	    local($ptr,$wake) = @_;
    	    eval q(({  &smp_mb();  &__asm__  &__volatile__( \\"@ up_op_read\\\\n\\" \\"1:	ldrex	lr, [%0]\\\\n\\" \\"	add	lr, lr, %1\\\\n\\" \\"	strex	ip, lr, [%0]\\\\n\\" \\"	teq	ip, #0\\\\n\\" \\"	bne	1b\\\\n\\" \\"	teq	lr, #0\\\\n\\" \\"	moveq	ip, %0\\\\n\\" \\"	bleq	\\" $wake : : \\"r\\" ($ptr), \\"I\\" (1) : \\"ip\\", \\"lr\\", \\"cc\\"); }));
	}' unless defined(&__up_op_read);
    } else {
	eval 'sub __down_op {
	    local($ptr,$fail) = @_;
    	    eval q(({  &__asm__  &__volatile__( \\"@ down_op\\\\n\\" \\"	mrs	ip, cpsr\\\\n\\" \\"	orr	lr, ip, #128\\\\n\\" \\"	msr	cpsr_c, lr\\\\n\\" \\"	ldr	lr, [%0]\\\\n\\" \\"	subs	lr, lr, %1\\\\n\\" \\"	str	lr, [%0]\\\\n\\" \\"	msr	cpsr_c, ip\\\\n\\" \\"	movmi	ip, %0\\\\n\\" \\"	blmi	\\" $fail : : \\"r\\" ($ptr), \\"I\\" (1) : \\"ip\\", \\"lr\\", \\"cc\\");  &smp_mb(); }));
	}' unless defined(&__down_op);
	eval 'sub __down_op_ret {
	    local($ptr,$fail) = @_;
    	    eval q(({ \'unsigned int ret\';  &__asm__  &__volatile__( \\"@ down_op_ret\\\\n\\" \\"	mrs	ip, cpsr\\\\n\\" \\"	orr	lr, ip, #128\\\\n\\" \\"	msr	cpsr_c, lr\\\\n\\" \\"	ldr	lr, [%1]\\\\n\\" \\"	subs	lr, lr, %2\\\\n\\" \\"	str	lr, [%1]\\\\n\\" \\"	msr	cpsr_c, ip\\\\n\\" \\"	movmi	ip, %1\\\\n\\" \\"	movpl	ip, #0\\\\n\\" \\"	blmi	\\" $fail \\"\\\\n\\" \\"	mov	%0, ip\\" : \\"=&r\\" ( &ret) : \\"r\\" ($ptr), \\"I\\" (1) : \\"ip\\", \\"lr\\", \\"cc\\");  &smp_mb();  &ret; }));
	}' unless defined(&__down_op_ret);
	eval 'sub __up_op {
	    local($ptr,$wake) = @_;
    	    eval q(({  &smp_mb();  &__asm__  &__volatile__( \\"@ up_op\\\\n\\" \\"	mrs	ip, cpsr\\\\n\\" \\"	orr	lr, ip, #128\\\\n\\" \\"	msr	cpsr_c, lr\\\\n\\" \\"	ldr	lr, [%0]\\\\n\\" \\"	adds	lr, lr, %1\\\\n\\" \\"	str	lr, [%0]\\\\n\\" \\"	msr	cpsr_c, ip\\\\n\\" \\"	movle	ip, %0\\\\n\\" \\"	blle	\\" $wake : : \\"r\\" ($ptr), \\"I\\" (1) : \\"ip\\", \\"lr\\", \\"cc\\"); }));
	}' unless defined(&__up_op);
	eval 'sub RW_LOCK_BIAS () {0x1000000;}' unless defined(&RW_LOCK_BIAS);
	eval 'sub RW_LOCK_BIAS_STR () {"0x01000000";}' unless defined(&RW_LOCK_BIAS_STR);
	eval 'sub __down_op_write {
	    local($ptr,$fail) = @_;
    	    eval q(({  &__asm__  &__volatile__( \\"@ down_op_write\\\\n\\" \\"	mrs	ip, cpsr\\\\n\\" \\"	orr	lr, ip, #128\\\\n\\" \\"	msr	cpsr_c, lr\\\\n\\" \\"	ldr	lr, [%0]\\\\n\\" \\"	subs	lr, lr, %1\\\\n\\" \\"	str	lr, [%0]\\\\n\\" \\"	msr	cpsr_c, ip\\\\n\\" \\"	movne	ip, %0\\\\n\\" \\"	blne	\\" $fail : : \\"r\\" ($ptr), \\"I\\" ( &RW_LOCK_BIAS) : \\"ip\\", \\"lr\\", \\"cc\\");  &smp_mb(); }));
	}' unless defined(&__down_op_write);
	eval 'sub __up_op_write {
	    local($ptr,$wake) = @_;
    	    eval q(({  &__asm__  &__volatile__( \\"@ up_op_write\\\\n\\" \\"	mrs	ip, cpsr\\\\n\\" \\"	orr	lr, ip, #128\\\\n\\" \\"	msr	cpsr_c, lr\\\\n\\" \\"	ldr	lr, [%0]\\\\n\\" \\"	adds	lr, lr, %1\\\\n\\" \\"	str	lr, [%0]\\\\n\\" \\"	msr	cpsr_c, ip\\\\n\\" \\"	movcs	ip, %0\\\\n\\" \\"	blcs	\\" $wake : : \\"r\\" ($ptr), \\"I\\" ( &RW_LOCK_BIAS) : \\"ip\\", \\"lr\\", \\"cc\\");  &smp_mb(); }));
	}' unless defined(&__up_op_write);
	eval 'sub __down_op_read {
	    local($ptr,$fail) = @_;
    	    eval q( &__down_op($ptr, $fail));
	}' unless defined(&__down_op_read);
	eval 'sub __up_op_read {
	    local($ptr,$wake) = @_;
    	    eval q(({  &smp_mb();  &__asm__  &__volatile__( \\"@ up_op_read\\\\n\\" \\"	mrs	ip, cpsr\\\\n\\" \\"	orr	lr, ip, #128\\\\n\\" \\"	msr	cpsr_c, lr\\\\n\\" \\"	ldr	lr, [%0]\\\\n\\" \\"	adds	lr, lr, %1\\\\n\\" \\"	str	lr, [%0]\\\\n\\" \\"	msr	cpsr_c, ip\\\\n\\" \\"	moveq	ip, %0\\\\n\\" \\"	bleq	\\" $wake : : \\"r\\" ($ptr), \\"I\\" (1) : \\"ip\\", \\"lr\\", \\"cc\\"); }));
	}' unless defined(&__up_op_read);
    }
}
1;
